<template>
  <ElForm>
    <ElFormItem label="Output Format">
      <OutputFormatSelect v-model="format" />
    </ElFormItem>
    <ElFormItem label="Video">
      <el-upload
        ref="upload"
        class="upload-demo"
        :action="uploadUrl"
        :limit="1"
        :on-exceed="handleExceed"
        :auto-upload="false"
        name="video"
        accept="video/*"
        :data="{ outputFormat: format?.value ?? 'mp4' }"
        @success="jobsStore.getJobs()"
      >
        <template #trigger>
          <el-button type="primary">select file</el-button>
        </template>
        <el-button class="ml-3" type="success" @click="submitUpload">
          Upload
        </el-button>
        <template #tip>
          <div class="el-upload__tip text-red">
            limit 1 file, new file will cover the old file
          </div>
        </template>
      </el-upload>
    </ElFormItem>
  </ElForm>
</template>

<script setup lang="ts">
import { genFileId } from "element-plus";
import type { UploadInstance, UploadProps, UploadRawFile } from "element-plus";
import { useJobsStore } from "@/stores/jobs";

const upload = ref<UploadInstance>();
const format = ref<undefined | { label: string; value: string }>();

const uploadUrl = `${import.meta.env.VITE_API_URL}/conversions`;
const jobsStore = useJobsStore();

const handleExceed: UploadProps["onExceed"] = (files) => {
  upload.value!.clearFiles();
  const file = files[0] as UploadRawFile;
  file.uid = genFileId();
  upload.value!.handleStart(file);
};

const submitUpload = () => {
  upload.value!.submit();
};
</script>
